@file:Suppress("UnstableApiUsage")

plugins {
  id("com.android.library")
  id("org.jetbrains.kotlin.android")
  id("com.sergei-lapin.napt")
  id("com.google.dagger.hilt.android") version libs.versions.dagger.get()
}

napt {
  additionalSourceSetsForTriggerGeneration.set(setOf("test", "androidTest"))
}

hilt { enableAggregatingTask = false }

android {
  namespace = "com.napt.samplebase"
  compileSdk = 32

  defaultConfig {
    minSdk = 21
    targetSdk = 32

    testInstrumentationRunner = "androidx.test.runner.AndroidJUnitRunner"
    consumerProguardFiles("consumer-rules.pro")
  }

  compileOptions {
    sourceCompatibility = JavaVersion.VERSION_11
    targetCompatibility = JavaVersion.VERSION_11
  }

  kotlinOptions.jvmTarget = JavaVersion.VERSION_11.toString()
  testOptions {
    unitTests.all {
      it.useJUnitPlatform()
    }
  }
}

dependencies {
  implementation(libs.androidXCoreKtx)
  implementation(libs.androidXAppcompat)
  implementation(libs.androidXConstraintlayout)
  implementation(libs.googleMaterial)

  implementation(libs.dagger)
  implementation(libs.hiltAndroid)
  annotationProcessor(libs.daggerCompiler)
  annotationProcessor(libs.hiltCompiler)

  testImplementation(libs.junitApi)
  testRuntimeOnly(libs.junitEngine)
  testImplementation(libs.junitParams)
}
