@file:Suppress("UnstableApiUsage")

plugins {
  id("com.android.application")
  id("org.jetbrains.kotlin.android")
  id("com.sergei-lapin.napt")
  id("com.google.dagger.hilt.android") version libs.versions.dagger.get()
}

napt {
  additionalSourceSetsForTriggerGeneration.set(setOf("test", "androidTest"))
}

hilt { enableAggregatingTask = false }

android {
  compileSdk = 33
  namespace = "com.slapin.napt.sample"

  buildFeatures { dataBinding = true }

  defaultConfig {
    applicationId = "com.slapin.napt.sample"
    minSdk = 21
    targetSdk = 33
    versionCode = 1
    versionName = "1.0"

    testInstrumentationRunner = "androidx.test.runner.AndroidJUnitRunner"
  }

  buildTypes {
    getByName("debug"){

    }
    getByName("release"){
      isMinifyEnabled = false
      proguardFiles(
        getDefaultProguardFile("proguard-android-optimize.txt"),
        "proguard-rules.pro"
      )
    }
  }

  compileOptions {
    sourceCompatibility = JavaVersion.VERSION_11
    targetCompatibility = JavaVersion.VERSION_11
  }

  kotlinOptions.jvmTarget = JavaVersion.VERSION_11.toString()

  testOptions {
    unitTests.all {
      it.useJUnitPlatform()
    }
  }
}

androidComponents { beforeVariants { builder -> builder.enable = builder.name == "debug" } }

dependencies {
  implementation(project(":SampleBase"))
  implementation(libs.androidXCoreKtx)
  implementation(libs.androidXAppcompat)
  implementation(libs.androidXConstraintlayout)
  implementation(libs.googleMaterial)

  implementation(libs.dagger)
  implementation(libs.hiltAndroid)
  annotationProcessor(libs.daggerCompiler)
  annotationProcessor(libs.hiltCompiler)

  testImplementation(libs.junitApi)
  testRuntimeOnly(libs.junitEngine)
  testImplementation(libs.junitParams)
}
